import * as i0 from '@angular/core';
import { model, input, output, ChangeDetectionStrategy, Component } from '@angular/core';
import { LibsUiComponentsLabelComponent } from '@libs-ui/components-label';
import { NgTemplateOutlet, UpperCasePipe } from '@angular/common';
import * as i1 from '@ngx-translate/core';
import { TranslateModule } from '@ngx-translate/core';

class LibsUiComponentsCardComponent {
    // #region INPUT
    isHidden = model(false);
    label = input();
    ignoreTitle = input();
    hasCollapseBtn = input();
    clickExactly = input();
    configCard = input();
    templateHeader = input(undefined);
    classIncludeBody = input();
    classIncludeHeader = input();
    classIncludeHeaderWhenHiddenContent = input();
    // #region OUTPUT
    outChangeStateShowContent = output();
    outFunctionsControl = output();
    ngOnInit() {
        this.outFunctionsControl.emit({
            changeHidden: this.handlerHiddenOrShowByTemplateHeader.bind(this)
        });
    }
    /* FUNCTIONS */
    async handlerHiddenOrShowContent(event, clickExactly) {
        event.stopPropagation();
        if (!this.hasCollapseBtn() || this.clickExactly() && !clickExactly) {
            return;
        }
        this.isHidden.update(value => !value);
        this.outChangeStateShowContent.emit(this.isHidden());
    }
    async handlerHiddenOrShowByTemplateHeader() {
        if (!this.hasCollapseBtn) {
            return;
        }
        this.isHidden.update(value => !value);
        this.outChangeStateShowContent.emit(this.isHidden());
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: LibsUiComponentsCardComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.13", type: LibsUiComponentsCardComponent, isStandalone: true, selector: "libs_ui-components-card", inputs: { isHidden: { classPropertyName: "isHidden", publicName: "isHidden", isSignal: true, isRequired: false, transformFunction: null }, label: { classPropertyName: "label", publicName: "label", isSignal: true, isRequired: false, transformFunction: null }, ignoreTitle: { classPropertyName: "ignoreTitle", publicName: "ignoreTitle", isSignal: true, isRequired: false, transformFunction: null }, hasCollapseBtn: { classPropertyName: "hasCollapseBtn", publicName: "hasCollapseBtn", isSignal: true, isRequired: false, transformFunction: null }, clickExactly: { classPropertyName: "clickExactly", publicName: "clickExactly", isSignal: true, isRequired: false, transformFunction: null }, configCard: { classPropertyName: "configCard", publicName: "configCard", isSignal: true, isRequired: false, transformFunction: null }, templateHeader: { classPropertyName: "templateHeader", publicName: "templateHeader", isSignal: true, isRequired: false, transformFunction: null }, classIncludeBody: { classPropertyName: "classIncludeBody", publicName: "classIncludeBody", isSignal: true, isRequired: false, transformFunction: null }, classIncludeHeader: { classPropertyName: "classIncludeHeader", publicName: "classIncludeHeader", isSignal: true, isRequired: false, transformFunction: null }, classIncludeHeaderWhenHiddenContent: { classPropertyName: "classIncludeHeaderWhenHiddenContent", publicName: "classIncludeHeaderWhenHiddenContent", isSignal: true, isRequired: false, transformFunction: null } }, outputs: { isHidden: "isHiddenChange", outChangeStateShowContent: "outChangeStateShowContent", outFunctionsControl: "outFunctionsControl" }, ngImport: i0, template: "@if (!ignoreTitle()) {\n  <div class=\"libs-ui-card-header {{ classIncludeHeader() }} {{ isHidden() ? classIncludeHeaderWhenHiddenContent() : '' }}\"\n    [class.pl-0]=\"configCard()?.ignorePaddingLeft\"\n    [class.bg-[#e9f1fe]]=\"!configCard()?.ignoreBackgroundHeader\"\n    [class.libs-ui-border-top-general]=\"!configCard()?.ignoreBorderHeader\"\n    [class.libs-ui-border-left-general]=\"!configCard()?.ignoreBorderHeader\"\n    [class.libs-ui-border-right-general]=\"!configCard()?.ignoreBorderHeader\"\n    [class.libs-ui-border-bottom-general]=\"!configCard()?.ignoreBorderHeader && isHidden()\"\n    [class.rounded-[4px]]=\"!configCard()?.ignoreBorderRadiusHeader\"\n    [class.cursor-pointer]=\"!clickExactly()\"\n    (click)=\"handlerHiddenOrShowContent($event,false)\">\n    @if (hasCollapseBtn() && !configCard()?.iconConRight) {\n      <span (click)=\"handlerHiddenOrShowContent($event,true)\"\n        [class]=\"'cursor-pointer mr-[8px] ' + (configCard()?.classIconInclude ?? 'before:!text-[#6a7383] ') + (isHidden() ? (configCard()?.classIconWhenHiddenContent || ' libs-ui-icon-chevron-right') : (configCard()?.classIconWhenShowContent || ' rotate-[90deg] libs-ui-icon-chevron-right'))\">\n      </span>\n    }\n    @if (!templateHeader()) {\n      <div [style.width]=\"configCard()?.width ||''\">\n        <libs_ui-components-label [popover]=\"label()?.popover\"\n          [labelLeft]=\"label()?.labelLeft\"\n          [labelLeftClass]=\"configCard()?.classIncludeLabel || 'libs-ui-font-h3s cursor-pointer'\"\n          [required]=\"label()?.required\"\n          [classInclude]=\"'cursor-pointer !mb-0'\"\n          (outLabelLeftClick)=\"handlerHiddenOrShowContent($event,true)\" />\n      </div>\n    }\n    @if (hasCollapseBtn() && configCard()?.iconConRight) {\n      <span\n        [class]=\"'cursor-pointer ml-auto ' + (configCard()?.classIconInclude ?? 'before:!text-[#6a7383] ') + (isHidden() ? (configCard()?.classIconWhenHiddenContent || ' libs-ui-icon-chevron-right rotate-[90deg]') : (configCard()?.classIconWhenShowContent || ' libs-ui-icon-chevron-right -rotate-[90deg]'))\"\n        (click)=\"handlerHiddenOrShowContent($event,true)\">\n      </span>\n    }\n    @if (templateHeader(); as templateHeader) {\n      <ng-container *ngTemplateOutlet=\"templateHeader\" />\n    }\n  </div>\n}\n\n@if (!isHidden()) {\n  <div class=\"libs-ui-card-body {{ classIncludeBody() }}\"\n    [class.libs-ui-border-general]=\"!configCard()?.ignoreBorderBody\">\n    <ng-content />\n  </div>\n}\n", styles: [".libs-ui-card-header{padding:6px 16px;display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center}.libs-ui-card-body{background-color:#fff;padding:16px 0;overflow-x:hidden;overflow-y:auto}\n"], dependencies: [{ kind: "ngmodule", type: TranslateModule }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: LibsUiComponentsLabelComponent, selector: "libs_ui-components-label", inputs: ["iconPopoverClass", "classInclude", "labelLeft", "labelLeftClass", "labelLeftBehindToggleButton", "popover", "required", "buttonsLeft", "disableButtonsLeft", "buttonsRight", "disableButtonsRight", "labelRight", "labelRightClass", "labelRightRequired", "hasToggle", "toggleSize", "toggleActive", "toggleDisable", "description", "descriptionClass", "buttonsDescription", "disableButtonsDescription", "buttonsDescriptionContainerClass", "onlyShowCount", "zIndexPopover", "timerDestroyPopover", "count", "limitLength"], outputs: ["outClickButton", "outSwitchEvent", "outLabelRightClick", "outLabelLeftClick"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: LibsUiComponentsCardComponent, decorators: [{
            type: Component,
            args: [{ selector: 'libs_ui-components-card', standalone: true, changeDetection: ChangeDetectionStrategy.OnPush, imports: [
                        TranslateModule, NgTemplateOutlet,
                        LibsUiComponentsLabelComponent
                    ], template: "@if (!ignoreTitle()) {\n  <div class=\"libs-ui-card-header {{ classIncludeHeader() }} {{ isHidden() ? classIncludeHeaderWhenHiddenContent() : '' }}\"\n    [class.pl-0]=\"configCard()?.ignorePaddingLeft\"\n    [class.bg-[#e9f1fe]]=\"!configCard()?.ignoreBackgroundHeader\"\n    [class.libs-ui-border-top-general]=\"!configCard()?.ignoreBorderHeader\"\n    [class.libs-ui-border-left-general]=\"!configCard()?.ignoreBorderHeader\"\n    [class.libs-ui-border-right-general]=\"!configCard()?.ignoreBorderHeader\"\n    [class.libs-ui-border-bottom-general]=\"!configCard()?.ignoreBorderHeader && isHidden()\"\n    [class.rounded-[4px]]=\"!configCard()?.ignoreBorderRadiusHeader\"\n    [class.cursor-pointer]=\"!clickExactly()\"\n    (click)=\"handlerHiddenOrShowContent($event,false)\">\n    @if (hasCollapseBtn() && !configCard()?.iconConRight) {\n      <span (click)=\"handlerHiddenOrShowContent($event,true)\"\n        [class]=\"'cursor-pointer mr-[8px] ' + (configCard()?.classIconInclude ?? 'before:!text-[#6a7383] ') + (isHidden() ? (configCard()?.classIconWhenHiddenContent || ' libs-ui-icon-chevron-right') : (configCard()?.classIconWhenShowContent || ' rotate-[90deg] libs-ui-icon-chevron-right'))\">\n      </span>\n    }\n    @if (!templateHeader()) {\n      <div [style.width]=\"configCard()?.width ||''\">\n        <libs_ui-components-label [popover]=\"label()?.popover\"\n          [labelLeft]=\"label()?.labelLeft\"\n          [labelLeftClass]=\"configCard()?.classIncludeLabel || 'libs-ui-font-h3s cursor-pointer'\"\n          [required]=\"label()?.required\"\n          [classInclude]=\"'cursor-pointer !mb-0'\"\n          (outLabelLeftClick)=\"handlerHiddenOrShowContent($event,true)\" />\n      </div>\n    }\n    @if (hasCollapseBtn() && configCard()?.iconConRight) {\n      <span\n        [class]=\"'cursor-pointer ml-auto ' + (configCard()?.classIconInclude ?? 'before:!text-[#6a7383] ') + (isHidden() ? (configCard()?.classIconWhenHiddenContent || ' libs-ui-icon-chevron-right rotate-[90deg]') : (configCard()?.classIconWhenShowContent || ' libs-ui-icon-chevron-right -rotate-[90deg]'))\"\n        (click)=\"handlerHiddenOrShowContent($event,true)\">\n      </span>\n    }\n    @if (templateHeader(); as templateHeader) {\n      <ng-container *ngTemplateOutlet=\"templateHeader\" />\n    }\n  </div>\n}\n\n@if (!isHidden()) {\n  <div class=\"libs-ui-card-body {{ classIncludeBody() }}\"\n    [class.libs-ui-border-general]=\"!configCard()?.ignoreBorderBody\">\n    <ng-content />\n  </div>\n}\n", styles: [".libs-ui-card-header{padding:6px 16px;display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center}.libs-ui-card-body{background-color:#fff;padding:16px 0;overflow-x:hidden;overflow-y:auto}\n"] }]
        }] });

class LibsUiComponentsCardWrapperComponent {
    // #region INPUT
    labelConfig = input();
    borderError = input(false);
    templateHeader = input();
    hasCollapseBtn = input(true);
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: LibsUiComponentsCardWrapperComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "18.2.13", type: LibsUiComponentsCardWrapperComponent, isStandalone: true, selector: "libs_ui-components-card-wrapper", inputs: { labelConfig: { classPropertyName: "labelConfig", publicName: "labelConfig", isSignal: true, isRequired: false, transformFunction: null }, borderError: { classPropertyName: "borderError", publicName: "borderError", isSignal: true, isRequired: false, transformFunction: null }, templateHeader: { classPropertyName: "templateHeader", publicName: "templateHeader", isSignal: true, isRequired: false, transformFunction: null }, hasCollapseBtn: { classPropertyName: "hasCollapseBtn", publicName: "hasCollapseBtn", isSignal: true, isRequired: false, transformFunction: null } }, ngImport: i0, template: "<div class=\"bg-[#ffffff] p-[16px] rounded-[8px] libs-ui-components-card-wrapper-node-shadow\"\n  [class.libs-ui-border-error-general]=\"borderError()\">\n  <libs_ui-components-card [label]=\"labelConfig()? {labelLeft: (labelConfig()?.labelLeft || '') | translate | uppercase, required: labelConfig()?.required}: {}\"\n    [ignoreTitle]=\"templateHeader() || labelConfig() ? false : true\"\n    [configCard]=\"{\n        ignoreBorderHeader: true, \n        ignoreBackgroundHeader: true,\n        classIncludeLabel: 'libs-ui-font-h4si !text-[#071631]',\n        ignoreBorderBody: true,\n        classIconInclude: '!text-[#071631] before:!text-[16px]'\n      }\"\n    [classIncludeHeader]=\"'!p-0'\"\n    [hasCollapseBtn]=\"hasCollapseBtn()\"\n    [classIncludeBody]=\"'!pb-0 ' + ((labelConfig() || templateHeader()) ? '' : '!p-0')\"\n    [templateHeader]=\"templateHeader()\">\n    <ng-content />\n  </libs_ui-components-card>\n</div>\n", styles: [".libs-ui-components-card-wrapper-node-shadow{box-shadow:0 4px 8px #0014330a,0 1px 1px #00143305}\n"], dependencies: [{ kind: "component", type: LibsUiComponentsCardComponent, selector: "libs_ui-components-card", inputs: ["isHidden", "label", "ignoreTitle", "hasCollapseBtn", "clickExactly", "configCard", "templateHeader", "classIncludeBody", "classIncludeHeader", "classIncludeHeaderWhenHiddenContent"], outputs: ["isHiddenChange", "outChangeStateShowContent", "outFunctionsControl"] }, { kind: "pipe", type: UpperCasePipe, name: "uppercase" }, { kind: "ngmodule", type: TranslateModule }, { kind: "pipe", type: i1.TranslatePipe, name: "translate" }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.13", ngImport: i0, type: LibsUiComponentsCardWrapperComponent, decorators: [{
            type: Component,
            args: [{ selector: 'libs_ui-components-card-wrapper', standalone: true, changeDetection: ChangeDetectionStrategy.OnPush, imports: [
                        LibsUiComponentsCardComponent, UpperCasePipe, TranslateModule
                    ], template: "<div class=\"bg-[#ffffff] p-[16px] rounded-[8px] libs-ui-components-card-wrapper-node-shadow\"\n  [class.libs-ui-border-error-general]=\"borderError()\">\n  <libs_ui-components-card [label]=\"labelConfig()? {labelLeft: (labelConfig()?.labelLeft || '') | translate | uppercase, required: labelConfig()?.required}: {}\"\n    [ignoreTitle]=\"templateHeader() || labelConfig() ? false : true\"\n    [configCard]=\"{\n        ignoreBorderHeader: true, \n        ignoreBackgroundHeader: true,\n        classIncludeLabel: 'libs-ui-font-h4si !text-[#071631]',\n        ignoreBorderBody: true,\n        classIconInclude: '!text-[#071631] before:!text-[16px]'\n      }\"\n    [classIncludeHeader]=\"'!p-0'\"\n    [hasCollapseBtn]=\"hasCollapseBtn()\"\n    [classIncludeBody]=\"'!pb-0 ' + ((labelConfig() || templateHeader()) ? '' : '!p-0')\"\n    [templateHeader]=\"templateHeader()\">\n    <ng-content />\n  </libs_ui-components-card>\n</div>\n", styles: [".libs-ui-components-card-wrapper-node-shadow{box-shadow:0 4px 8px #0014330a,0 1px 1px #00143305}\n"] }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { LibsUiComponentsCardComponent, LibsUiComponentsCardWrapperComponent };
//# sourceMappingURL=libs-ui-components-card.mjs.map
